// source: problem.proto
/**
 * @fileoverview
 * @enhanceable
 * @suppress {messageConventions} JS Compiler reports an error if a variable or
 *     field starts with 'MSG_' and isn't a translatable message.
 * @public
 */
// GENERATED CODE -- DO NOT EDIT!

var jspb = require('google-protobuf');
var goog = jspb;
var global = Function('return this')();

goog.exportSymbol('proto.DataAugmentation', null, global);
goog.exportSymbol('proto.ForecastingHorizon', null, global);
goog.exportSymbol('proto.PerformanceMetric', null, global);
goog.exportSymbol('proto.Problem', null, global);
goog.exportSymbol('proto.ProblemDescription', null, global);
goog.exportSymbol('proto.ProblemInput', null, global);
goog.exportSymbol('proto.ProblemPerformanceMetric', null, global);
goog.exportSymbol('proto.ProblemPrivilegedData', null, global);
goog.exportSymbol('proto.ProblemTarget', null, global);
goog.exportSymbol('proto.TaskKeyword', null, global);
/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.ProblemPerformanceMetric = function(opt_data) {
  jspb.Message.initialize(this, opt_data, 0, -1, null, null);
};
goog.inherits(proto.ProblemPerformanceMetric, jspb.Message);
if (goog.DEBUG && !COMPILED) {
  /**
   * @public
   * @override
   */
  proto.ProblemPerformanceMetric.displayName = 'proto.ProblemPerformanceMetric';
}
/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.Problem = function(opt_data) {
  jspb.Message.initialize(this, opt_data, 0, -1, proto.Problem.repeatedFields_, null);
};
goog.inherits(proto.Problem, jspb.Message);
if (goog.DEBUG && !COMPILED) {
  /**
   * @public
   * @override
   */
  proto.Problem.displayName = 'proto.Problem';
}
/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.ProblemTarget = function(opt_data) {
  jspb.Message.initialize(this, opt_data, 0, -1, null, null);
};
goog.inherits(proto.ProblemTarget, jspb.Message);
if (goog.DEBUG && !COMPILED) {
  /**
   * @public
   * @override
   */
  proto.ProblemTarget.displayName = 'proto.ProblemTarget';
}
/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.ProblemPrivilegedData = function(opt_data) {
  jspb.Message.initialize(this, opt_data, 0, -1, null, null);
};
goog.inherits(proto.ProblemPrivilegedData, jspb.Message);
if (goog.DEBUG && !COMPILED) {
  /**
   * @public
   * @override
   */
  proto.ProblemPrivilegedData.displayName = 'proto.ProblemPrivilegedData';
}
/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.ForecastingHorizon = function(opt_data) {
  jspb.Message.initialize(this, opt_data, 0, -1, null, null);
};
goog.inherits(proto.ForecastingHorizon, jspb.Message);
if (goog.DEBUG && !COMPILED) {
  /**
   * @public
   * @override
   */
  proto.ForecastingHorizon.displayName = 'proto.ForecastingHorizon';
}
/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.ProblemInput = function(opt_data) {
  jspb.Message.initialize(this, opt_data, 0, -1, proto.ProblemInput.repeatedFields_, null);
};
goog.inherits(proto.ProblemInput, jspb.Message);
if (goog.DEBUG && !COMPILED) {
  /**
   * @public
   * @override
   */
  proto.ProblemInput.displayName = 'proto.ProblemInput';
}
/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.DataAugmentation = function(opt_data) {
  jspb.Message.initialize(this, opt_data, 0, -1, proto.DataAugmentation.repeatedFields_, null);
};
goog.inherits(proto.DataAugmentation, jspb.Message);
if (goog.DEBUG && !COMPILED) {
  /**
   * @public
   * @override
   */
  proto.DataAugmentation.displayName = 'proto.DataAugmentation';
}
/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.ProblemDescription = function(opt_data) {
  jspb.Message.initialize(this, opt_data, 0, -1, proto.ProblemDescription.repeatedFields_, null);
};
goog.inherits(proto.ProblemDescription, jspb.Message);
if (goog.DEBUG && !COMPILED) {
  /**
   * @public
   * @override
   */
  proto.ProblemDescription.displayName = 'proto.ProblemDescription';
}



if (jspb.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * Optional fields that are not set will be set to undefined.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     net/proto2/compiler/js/internal/generator.cc#kKeyword.
 * @param {boolean=} opt_includeInstance Deprecated. whether to include the
 *     JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @return {!Object}
 */
proto.ProblemPerformanceMetric.prototype.toObject = function(opt_includeInstance) {
  return proto.ProblemPerformanceMetric.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Deprecated. Whether to include
 *     the JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.ProblemPerformanceMetric} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.ProblemPerformanceMetric.toObject = function(includeInstance, msg) {
  var f, obj = {
    metric: jspb.Message.getFieldWithDefault(msg, 1, 0),
    k: jspb.Message.getFieldWithDefault(msg, 2, 0),
    posLabel: jspb.Message.getFieldWithDefault(msg, 3, "")
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.ProblemPerformanceMetric}
 */
proto.ProblemPerformanceMetric.deserializeBinary = function(bytes) {
  var reader = new jspb.BinaryReader(bytes);
  var msg = new proto.ProblemPerformanceMetric;
  return proto.ProblemPerformanceMetric.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.ProblemPerformanceMetric} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.ProblemPerformanceMetric}
 */
proto.ProblemPerformanceMetric.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = /** @type {!proto.PerformanceMetric} */ (reader.readEnum());
      msg.setMetric(value);
      break;
    case 2:
      var value = /** @type {number} */ (reader.readInt32());
      msg.setK(value);
      break;
    case 3:
      var value = /** @type {string} */ (reader.readString());
      msg.setPosLabel(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.ProblemPerformanceMetric.prototype.serializeBinary = function() {
  var writer = new jspb.BinaryWriter();
  proto.ProblemPerformanceMetric.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.ProblemPerformanceMetric} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.ProblemPerformanceMetric.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getMetric();
  if (f !== 0.0) {
    writer.writeEnum(
      1,
      f
    );
  }
  f = message.getK();
  if (f !== 0) {
    writer.writeInt32(
      2,
      f
    );
  }
  f = message.getPosLabel();
  if (f.length > 0) {
    writer.writeString(
      3,
      f
    );
  }
};


/**
 * optional PerformanceMetric metric = 1;
 * @return {!proto.PerformanceMetric}
 */
proto.ProblemPerformanceMetric.prototype.getMetric = function() {
  return /** @type {!proto.PerformanceMetric} */ (jspb.Message.getFieldWithDefault(this, 1, 0));
};


/**
 * @param {!proto.PerformanceMetric} value
 * @return {!proto.ProblemPerformanceMetric} returns this
 */
proto.ProblemPerformanceMetric.prototype.setMetric = function(value) {
  return jspb.Message.setProto3EnumField(this, 1, value);
};


/**
 * optional int32 k = 2;
 * @return {number}
 */
proto.ProblemPerformanceMetric.prototype.getK = function() {
  return /** @type {number} */ (jspb.Message.getFieldWithDefault(this, 2, 0));
};


/**
 * @param {number} value
 * @return {!proto.ProblemPerformanceMetric} returns this
 */
proto.ProblemPerformanceMetric.prototype.setK = function(value) {
  return jspb.Message.setProto3IntField(this, 2, value);
};


/**
 * optional string pos_label = 3;
 * @return {string}
 */
proto.ProblemPerformanceMetric.prototype.getPosLabel = function() {
  return /** @type {string} */ (jspb.Message.getFieldWithDefault(this, 3, ""));
};


/**
 * @param {string} value
 * @return {!proto.ProblemPerformanceMetric} returns this
 */
proto.ProblemPerformanceMetric.prototype.setPosLabel = function(value) {
  return jspb.Message.setProto3StringField(this, 3, value);
};



/**
 * List of repeated fields within this message type.
 * @private {!Array<number>}
 * @const
 */
proto.Problem.repeatedFields_ = [8,7];



if (jspb.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * Optional fields that are not set will be set to undefined.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     net/proto2/compiler/js/internal/generator.cc#kKeyword.
 * @param {boolean=} opt_includeInstance Deprecated. whether to include the
 *     JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @return {!Object}
 */
proto.Problem.prototype.toObject = function(opt_includeInstance) {
  return proto.Problem.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Deprecated. Whether to include
 *     the JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.Problem} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.Problem.toObject = function(includeInstance, msg) {
  var f, obj = {
    taskKeywordsList: (f = jspb.Message.getRepeatedField(msg, 8)) == null ? undefined : f,
    performanceMetricsList: jspb.Message.toObjectList(msg.getPerformanceMetricsList(),
    proto.ProblemPerformanceMetric.toObject, includeInstance)
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.Problem}
 */
proto.Problem.deserializeBinary = function(bytes) {
  var reader = new jspb.BinaryReader(bytes);
  var msg = new proto.Problem;
  return proto.Problem.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.Problem} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.Problem}
 */
proto.Problem.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 8:
      var value = /** @type {!Array<!proto.TaskKeyword>} */ (reader.readPackedEnum());
      msg.setTaskKeywordsList(value);
      break;
    case 7:
      var value = new proto.ProblemPerformanceMetric;
      reader.readMessage(value,proto.ProblemPerformanceMetric.deserializeBinaryFromReader);
      msg.addPerformanceMetrics(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.Problem.prototype.serializeBinary = function() {
  var writer = new jspb.BinaryWriter();
  proto.Problem.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.Problem} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.Problem.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getTaskKeywordsList();
  if (f.length > 0) {
    writer.writePackedEnum(
      8,
      f
    );
  }
  f = message.getPerformanceMetricsList();
  if (f.length > 0) {
    writer.writeRepeatedMessage(
      7,
      f,
      proto.ProblemPerformanceMetric.serializeBinaryToWriter
    );
  }
};


/**
 * repeated TaskKeyword task_keywords = 8;
 * @return {!Array<!proto.TaskKeyword>}
 */
proto.Problem.prototype.getTaskKeywordsList = function() {
  return /** @type {!Array<!proto.TaskKeyword>} */ (jspb.Message.getRepeatedField(this, 8));
};


/**
 * @param {!Array<!proto.TaskKeyword>} value
 * @return {!proto.Problem} returns this
 */
proto.Problem.prototype.setTaskKeywordsList = function(value) {
  return jspb.Message.setField(this, 8, value || []);
};


/**
 * @param {!proto.TaskKeyword} value
 * @param {number=} opt_index
 * @return {!proto.Problem} returns this
 */
proto.Problem.prototype.addTaskKeywords = function(value, opt_index) {
  return jspb.Message.addToRepeatedField(this, 8, value, opt_index);
};


/**
 * Clears the list making it empty but non-null.
 * @return {!proto.Problem} returns this
 */
proto.Problem.prototype.clearTaskKeywordsList = function() {
  return this.setTaskKeywordsList([]);
};


/**
 * repeated ProblemPerformanceMetric performance_metrics = 7;
 * @return {!Array<!proto.ProblemPerformanceMetric>}
 */
proto.Problem.prototype.getPerformanceMetricsList = function() {
  return /** @type{!Array<!proto.ProblemPerformanceMetric>} */ (
    jspb.Message.getRepeatedWrapperField(this, proto.ProblemPerformanceMetric, 7));
};


/**
 * @param {!Array<!proto.ProblemPerformanceMetric>} value
 * @return {!proto.Problem} returns this
*/
proto.Problem.prototype.setPerformanceMetricsList = function(value) {
  return jspb.Message.setRepeatedWrapperField(this, 7, value);
};


/**
 * @param {!proto.ProblemPerformanceMetric=} opt_value
 * @param {number=} opt_index
 * @return {!proto.ProblemPerformanceMetric}
 */
proto.Problem.prototype.addPerformanceMetrics = function(opt_value, opt_index) {
  return jspb.Message.addToRepeatedWrapperField(this, 7, opt_value, proto.ProblemPerformanceMetric, opt_index);
};


/**
 * Clears the list making it empty but non-null.
 * @return {!proto.Problem} returns this
 */
proto.Problem.prototype.clearPerformanceMetricsList = function() {
  return this.setPerformanceMetricsList([]);
};





if (jspb.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * Optional fields that are not set will be set to undefined.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     net/proto2/compiler/js/internal/generator.cc#kKeyword.
 * @param {boolean=} opt_includeInstance Deprecated. whether to include the
 *     JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @return {!Object}
 */
proto.ProblemTarget.prototype.toObject = function(opt_includeInstance) {
  return proto.ProblemTarget.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Deprecated. Whether to include
 *     the JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.ProblemTarget} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.ProblemTarget.toObject = function(includeInstance, msg) {
  var f, obj = {
    targetIndex: jspb.Message.getFieldWithDefault(msg, 1, 0),
    resourceId: jspb.Message.getFieldWithDefault(msg, 2, ""),
    columnIndex: jspb.Message.getFieldWithDefault(msg, 3, 0),
    columnName: jspb.Message.getFieldWithDefault(msg, 4, ""),
    clustersNumber: jspb.Message.getFieldWithDefault(msg, 5, 0)
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.ProblemTarget}
 */
proto.ProblemTarget.deserializeBinary = function(bytes) {
  var reader = new jspb.BinaryReader(bytes);
  var msg = new proto.ProblemTarget;
  return proto.ProblemTarget.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.ProblemTarget} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.ProblemTarget}
 */
proto.ProblemTarget.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = /** @type {number} */ (reader.readInt32());
      msg.setTargetIndex(value);
      break;
    case 2:
      var value = /** @type {string} */ (reader.readString());
      msg.setResourceId(value);
      break;
    case 3:
      var value = /** @type {number} */ (reader.readInt32());
      msg.setColumnIndex(value);
      break;
    case 4:
      var value = /** @type {string} */ (reader.readString());
      msg.setColumnName(value);
      break;
    case 5:
      var value = /** @type {number} */ (reader.readInt32());
      msg.setClustersNumber(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.ProblemTarget.prototype.serializeBinary = function() {
  var writer = new jspb.BinaryWriter();
  proto.ProblemTarget.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.ProblemTarget} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.ProblemTarget.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getTargetIndex();
  if (f !== 0) {
    writer.writeInt32(
      1,
      f
    );
  }
  f = message.getResourceId();
  if (f.length > 0) {
    writer.writeString(
      2,
      f
    );
  }
  f = message.getColumnIndex();
  if (f !== 0) {
    writer.writeInt32(
      3,
      f
    );
  }
  f = message.getColumnName();
  if (f.length > 0) {
    writer.writeString(
      4,
      f
    );
  }
  f = message.getClustersNumber();
  if (f !== 0) {
    writer.writeInt32(
      5,
      f
    );
  }
};


/**
 * optional int32 target_index = 1;
 * @return {number}
 */
proto.ProblemTarget.prototype.getTargetIndex = function() {
  return /** @type {number} */ (jspb.Message.getFieldWithDefault(this, 1, 0));
};


/**
 * @param {number} value
 * @return {!proto.ProblemTarget} returns this
 */
proto.ProblemTarget.prototype.setTargetIndex = function(value) {
  return jspb.Message.setProto3IntField(this, 1, value);
};


/**
 * optional string resource_id = 2;
 * @return {string}
 */
proto.ProblemTarget.prototype.getResourceId = function() {
  return /** @type {string} */ (jspb.Message.getFieldWithDefault(this, 2, ""));
};


/**
 * @param {string} value
 * @return {!proto.ProblemTarget} returns this
 */
proto.ProblemTarget.prototype.setResourceId = function(value) {
  return jspb.Message.setProto3StringField(this, 2, value);
};


/**
 * optional int32 column_index = 3;
 * @return {number}
 */
proto.ProblemTarget.prototype.getColumnIndex = function() {
  return /** @type {number} */ (jspb.Message.getFieldWithDefault(this, 3, 0));
};


/**
 * @param {number} value
 * @return {!proto.ProblemTarget} returns this
 */
proto.ProblemTarget.prototype.setColumnIndex = function(value) {
  return jspb.Message.setProto3IntField(this, 3, value);
};


/**
 * optional string column_name = 4;
 * @return {string}
 */
proto.ProblemTarget.prototype.getColumnName = function() {
  return /** @type {string} */ (jspb.Message.getFieldWithDefault(this, 4, ""));
};


/**
 * @param {string} value
 * @return {!proto.ProblemTarget} returns this
 */
proto.ProblemTarget.prototype.setColumnName = function(value) {
  return jspb.Message.setProto3StringField(this, 4, value);
};


/**
 * optional int32 clusters_number = 5;
 * @return {number}
 */
proto.ProblemTarget.prototype.getClustersNumber = function() {
  return /** @type {number} */ (jspb.Message.getFieldWithDefault(this, 5, 0));
};


/**
 * @param {number} value
 * @return {!proto.ProblemTarget} returns this
 */
proto.ProblemTarget.prototype.setClustersNumber = function(value) {
  return jspb.Message.setProto3IntField(this, 5, value);
};





if (jspb.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * Optional fields that are not set will be set to undefined.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     net/proto2/compiler/js/internal/generator.cc#kKeyword.
 * @param {boolean=} opt_includeInstance Deprecated. whether to include the
 *     JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @return {!Object}
 */
proto.ProblemPrivilegedData.prototype.toObject = function(opt_includeInstance) {
  return proto.ProblemPrivilegedData.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Deprecated. Whether to include
 *     the JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.ProblemPrivilegedData} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.ProblemPrivilegedData.toObject = function(includeInstance, msg) {
  var f, obj = {
    privilegedDataIndex: jspb.Message.getFieldWithDefault(msg, 1, 0),
    resourceId: jspb.Message.getFieldWithDefault(msg, 2, ""),
    columnIndex: jspb.Message.getFieldWithDefault(msg, 3, 0),
    columnName: jspb.Message.getFieldWithDefault(msg, 4, "")
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.ProblemPrivilegedData}
 */
proto.ProblemPrivilegedData.deserializeBinary = function(bytes) {
  var reader = new jspb.BinaryReader(bytes);
  var msg = new proto.ProblemPrivilegedData;
  return proto.ProblemPrivilegedData.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.ProblemPrivilegedData} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.ProblemPrivilegedData}
 */
proto.ProblemPrivilegedData.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = /** @type {number} */ (reader.readInt32());
      msg.setPrivilegedDataIndex(value);
      break;
    case 2:
      var value = /** @type {string} */ (reader.readString());
      msg.setResourceId(value);
      break;
    case 3:
      var value = /** @type {number} */ (reader.readInt32());
      msg.setColumnIndex(value);
      break;
    case 4:
      var value = /** @type {string} */ (reader.readString());
      msg.setColumnName(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.ProblemPrivilegedData.prototype.serializeBinary = function() {
  var writer = new jspb.BinaryWriter();
  proto.ProblemPrivilegedData.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.ProblemPrivilegedData} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.ProblemPrivilegedData.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getPrivilegedDataIndex();
  if (f !== 0) {
    writer.writeInt32(
      1,
      f
    );
  }
  f = message.getResourceId();
  if (f.length > 0) {
    writer.writeString(
      2,
      f
    );
  }
  f = message.getColumnIndex();
  if (f !== 0) {
    writer.writeInt32(
      3,
      f
    );
  }
  f = message.getColumnName();
  if (f.length > 0) {
    writer.writeString(
      4,
      f
    );
  }
};


/**
 * optional int32 privileged_data_index = 1;
 * @return {number}
 */
proto.ProblemPrivilegedData.prototype.getPrivilegedDataIndex = function() {
  return /** @type {number} */ (jspb.Message.getFieldWithDefault(this, 1, 0));
};


/**
 * @param {number} value
 * @return {!proto.ProblemPrivilegedData} returns this
 */
proto.ProblemPrivilegedData.prototype.setPrivilegedDataIndex = function(value) {
  return jspb.Message.setProto3IntField(this, 1, value);
};


/**
 * optional string resource_id = 2;
 * @return {string}
 */
proto.ProblemPrivilegedData.prototype.getResourceId = function() {
  return /** @type {string} */ (jspb.Message.getFieldWithDefault(this, 2, ""));
};


/**
 * @param {string} value
 * @return {!proto.ProblemPrivilegedData} returns this
 */
proto.ProblemPrivilegedData.prototype.setResourceId = function(value) {
  return jspb.Message.setProto3StringField(this, 2, value);
};


/**
 * optional int32 column_index = 3;
 * @return {number}
 */
proto.ProblemPrivilegedData.prototype.getColumnIndex = function() {
  return /** @type {number} */ (jspb.Message.getFieldWithDefault(this, 3, 0));
};


/**
 * @param {number} value
 * @return {!proto.ProblemPrivilegedData} returns this
 */
proto.ProblemPrivilegedData.prototype.setColumnIndex = function(value) {
  return jspb.Message.setProto3IntField(this, 3, value);
};


/**
 * optional string column_name = 4;
 * @return {string}
 */
proto.ProblemPrivilegedData.prototype.getColumnName = function() {
  return /** @type {string} */ (jspb.Message.getFieldWithDefault(this, 4, ""));
};


/**
 * @param {string} value
 * @return {!proto.ProblemPrivilegedData} returns this
 */
proto.ProblemPrivilegedData.prototype.setColumnName = function(value) {
  return jspb.Message.setProto3StringField(this, 4, value);
};





if (jspb.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * Optional fields that are not set will be set to undefined.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     net/proto2/compiler/js/internal/generator.cc#kKeyword.
 * @param {boolean=} opt_includeInstance Deprecated. whether to include the
 *     JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @return {!Object}
 */
proto.ForecastingHorizon.prototype.toObject = function(opt_includeInstance) {
  return proto.ForecastingHorizon.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Deprecated. Whether to include
 *     the JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.ForecastingHorizon} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.ForecastingHorizon.toObject = function(includeInstance, msg) {
  var f, obj = {
    resourceId: jspb.Message.getFieldWithDefault(msg, 1, ""),
    columnIndex: jspb.Message.getFieldWithDefault(msg, 2, 0),
    columnName: jspb.Message.getFieldWithDefault(msg, 3, ""),
    horizonValue: jspb.Message.getFloatingPointFieldWithDefault(msg, 4, 0.0)
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.ForecastingHorizon}
 */
proto.ForecastingHorizon.deserializeBinary = function(bytes) {
  var reader = new jspb.BinaryReader(bytes);
  var msg = new proto.ForecastingHorizon;
  return proto.ForecastingHorizon.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.ForecastingHorizon} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.ForecastingHorizon}
 */
proto.ForecastingHorizon.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = /** @type {string} */ (reader.readString());
      msg.setResourceId(value);
      break;
    case 2:
      var value = /** @type {number} */ (reader.readInt32());
      msg.setColumnIndex(value);
      break;
    case 3:
      var value = /** @type {string} */ (reader.readString());
      msg.setColumnName(value);
      break;
    case 4:
      var value = /** @type {number} */ (reader.readDouble());
      msg.setHorizonValue(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.ForecastingHorizon.prototype.serializeBinary = function() {
  var writer = new jspb.BinaryWriter();
  proto.ForecastingHorizon.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.ForecastingHorizon} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.ForecastingHorizon.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getResourceId();
  if (f.length > 0) {
    writer.writeString(
      1,
      f
    );
  }
  f = message.getColumnIndex();
  if (f !== 0) {
    writer.writeInt32(
      2,
      f
    );
  }
  f = message.getColumnName();
  if (f.length > 0) {
    writer.writeString(
      3,
      f
    );
  }
  f = message.getHorizonValue();
  if (f !== 0.0) {
    writer.writeDouble(
      4,
      f
    );
  }
};


/**
 * optional string resource_id = 1;
 * @return {string}
 */
proto.ForecastingHorizon.prototype.getResourceId = function() {
  return /** @type {string} */ (jspb.Message.getFieldWithDefault(this, 1, ""));
};


/**
 * @param {string} value
 * @return {!proto.ForecastingHorizon} returns this
 */
proto.ForecastingHorizon.prototype.setResourceId = function(value) {
  return jspb.Message.setProto3StringField(this, 1, value);
};


/**
 * optional int32 column_index = 2;
 * @return {number}
 */
proto.ForecastingHorizon.prototype.getColumnIndex = function() {
  return /** @type {number} */ (jspb.Message.getFieldWithDefault(this, 2, 0));
};


/**
 * @param {number} value
 * @return {!proto.ForecastingHorizon} returns this
 */
proto.ForecastingHorizon.prototype.setColumnIndex = function(value) {
  return jspb.Message.setProto3IntField(this, 2, value);
};


/**
 * optional string column_name = 3;
 * @return {string}
 */
proto.ForecastingHorizon.prototype.getColumnName = function() {
  return /** @type {string} */ (jspb.Message.getFieldWithDefault(this, 3, ""));
};


/**
 * @param {string} value
 * @return {!proto.ForecastingHorizon} returns this
 */
proto.ForecastingHorizon.prototype.setColumnName = function(value) {
  return jspb.Message.setProto3StringField(this, 3, value);
};


/**
 * optional double horizon_value = 4;
 * @return {number}
 */
proto.ForecastingHorizon.prototype.getHorizonValue = function() {
  return /** @type {number} */ (jspb.Message.getFloatingPointFieldWithDefault(this, 4, 0.0));
};


/**
 * @param {number} value
 * @return {!proto.ForecastingHorizon} returns this
 */
proto.ForecastingHorizon.prototype.setHorizonValue = function(value) {
  return jspb.Message.setProto3FloatField(this, 4, value);
};



/**
 * List of repeated fields within this message type.
 * @private {!Array<number>}
 * @const
 */
proto.ProblemInput.repeatedFields_ = [2,3];



if (jspb.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * Optional fields that are not set will be set to undefined.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     net/proto2/compiler/js/internal/generator.cc#kKeyword.
 * @param {boolean=} opt_includeInstance Deprecated. whether to include the
 *     JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @return {!Object}
 */
proto.ProblemInput.prototype.toObject = function(opt_includeInstance) {
  return proto.ProblemInput.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Deprecated. Whether to include
 *     the JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.ProblemInput} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.ProblemInput.toObject = function(includeInstance, msg) {
  var f, obj = {
    datasetId: jspb.Message.getFieldWithDefault(msg, 1, ""),
    targetsList: jspb.Message.toObjectList(msg.getTargetsList(),
    proto.ProblemTarget.toObject, includeInstance),
    privilegedDataList: jspb.Message.toObjectList(msg.getPrivilegedDataList(),
    proto.ProblemPrivilegedData.toObject, includeInstance),
    forecastingHorizon: (f = msg.getForecastingHorizon()) && proto.ForecastingHorizon.toObject(includeInstance, f)
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.ProblemInput}
 */
proto.ProblemInput.deserializeBinary = function(bytes) {
  var reader = new jspb.BinaryReader(bytes);
  var msg = new proto.ProblemInput;
  return proto.ProblemInput.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.ProblemInput} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.ProblemInput}
 */
proto.ProblemInput.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = /** @type {string} */ (reader.readString());
      msg.setDatasetId(value);
      break;
    case 2:
      var value = new proto.ProblemTarget;
      reader.readMessage(value,proto.ProblemTarget.deserializeBinaryFromReader);
      msg.addTargets(value);
      break;
    case 3:
      var value = new proto.ProblemPrivilegedData;
      reader.readMessage(value,proto.ProblemPrivilegedData.deserializeBinaryFromReader);
      msg.addPrivilegedData(value);
      break;
    case 4:
      var value = new proto.ForecastingHorizon;
      reader.readMessage(value,proto.ForecastingHorizon.deserializeBinaryFromReader);
      msg.setForecastingHorizon(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.ProblemInput.prototype.serializeBinary = function() {
  var writer = new jspb.BinaryWriter();
  proto.ProblemInput.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.ProblemInput} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.ProblemInput.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getDatasetId();
  if (f.length > 0) {
    writer.writeString(
      1,
      f
    );
  }
  f = message.getTargetsList();
  if (f.length > 0) {
    writer.writeRepeatedMessage(
      2,
      f,
      proto.ProblemTarget.serializeBinaryToWriter
    );
  }
  f = message.getPrivilegedDataList();
  if (f.length > 0) {
    writer.writeRepeatedMessage(
      3,
      f,
      proto.ProblemPrivilegedData.serializeBinaryToWriter
    );
  }
  f = message.getForecastingHorizon();
  if (f != null) {
    writer.writeMessage(
      4,
      f,
      proto.ForecastingHorizon.serializeBinaryToWriter
    );
  }
};


/**
 * optional string dataset_id = 1;
 * @return {string}
 */
proto.ProblemInput.prototype.getDatasetId = function() {
  return /** @type {string} */ (jspb.Message.getFieldWithDefault(this, 1, ""));
};


/**
 * @param {string} value
 * @return {!proto.ProblemInput} returns this
 */
proto.ProblemInput.prototype.setDatasetId = function(value) {
  return jspb.Message.setProto3StringField(this, 1, value);
};


/**
 * repeated ProblemTarget targets = 2;
 * @return {!Array<!proto.ProblemTarget>}
 */
proto.ProblemInput.prototype.getTargetsList = function() {
  return /** @type{!Array<!proto.ProblemTarget>} */ (
    jspb.Message.getRepeatedWrapperField(this, proto.ProblemTarget, 2));
};


/**
 * @param {!Array<!proto.ProblemTarget>} value
 * @return {!proto.ProblemInput} returns this
*/
proto.ProblemInput.prototype.setTargetsList = function(value) {
  return jspb.Message.setRepeatedWrapperField(this, 2, value);
};


/**
 * @param {!proto.ProblemTarget=} opt_value
 * @param {number=} opt_index
 * @return {!proto.ProblemTarget}
 */
proto.ProblemInput.prototype.addTargets = function(opt_value, opt_index) {
  return jspb.Message.addToRepeatedWrapperField(this, 2, opt_value, proto.ProblemTarget, opt_index);
};


/**
 * Clears the list making it empty but non-null.
 * @return {!proto.ProblemInput} returns this
 */
proto.ProblemInput.prototype.clearTargetsList = function() {
  return this.setTargetsList([]);
};


/**
 * repeated ProblemPrivilegedData privileged_data = 3;
 * @return {!Array<!proto.ProblemPrivilegedData>}
 */
proto.ProblemInput.prototype.getPrivilegedDataList = function() {
  return /** @type{!Array<!proto.ProblemPrivilegedData>} */ (
    jspb.Message.getRepeatedWrapperField(this, proto.ProblemPrivilegedData, 3));
};


/**
 * @param {!Array<!proto.ProblemPrivilegedData>} value
 * @return {!proto.ProblemInput} returns this
*/
proto.ProblemInput.prototype.setPrivilegedDataList = function(value) {
  return jspb.Message.setRepeatedWrapperField(this, 3, value);
};


/**
 * @param {!proto.ProblemPrivilegedData=} opt_value
 * @param {number=} opt_index
 * @return {!proto.ProblemPrivilegedData}
 */
proto.ProblemInput.prototype.addPrivilegedData = function(opt_value, opt_index) {
  return jspb.Message.addToRepeatedWrapperField(this, 3, opt_value, proto.ProblemPrivilegedData, opt_index);
};


/**
 * Clears the list making it empty but non-null.
 * @return {!proto.ProblemInput} returns this
 */
proto.ProblemInput.prototype.clearPrivilegedDataList = function() {
  return this.setPrivilegedDataList([]);
};


/**
 * optional ForecastingHorizon forecasting_horizon = 4;
 * @return {?proto.ForecastingHorizon}
 */
proto.ProblemInput.prototype.getForecastingHorizon = function() {
  return /** @type{?proto.ForecastingHorizon} */ (
    jspb.Message.getWrapperField(this, proto.ForecastingHorizon, 4));
};


/**
 * @param {?proto.ForecastingHorizon|undefined} value
 * @return {!proto.ProblemInput} returns this
*/
proto.ProblemInput.prototype.setForecastingHorizon = function(value) {
  return jspb.Message.setWrapperField(this, 4, value);
};


/**
 * Clears the message field making it undefined.
 * @return {!proto.ProblemInput} returns this
 */
proto.ProblemInput.prototype.clearForecastingHorizon = function() {
  return this.setForecastingHorizon(undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.ProblemInput.prototype.hasForecastingHorizon = function() {
  return jspb.Message.getField(this, 4) != null;
};



/**
 * List of repeated fields within this message type.
 * @private {!Array<number>}
 * @const
 */
proto.DataAugmentation.repeatedFields_ = [1,2];



if (jspb.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * Optional fields that are not set will be set to undefined.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     net/proto2/compiler/js/internal/generator.cc#kKeyword.
 * @param {boolean=} opt_includeInstance Deprecated. whether to include the
 *     JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @return {!Object}
 */
proto.DataAugmentation.prototype.toObject = function(opt_includeInstance) {
  return proto.DataAugmentation.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Deprecated. Whether to include
 *     the JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.DataAugmentation} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.DataAugmentation.toObject = function(includeInstance, msg) {
  var f, obj = {
    domainList: (f = jspb.Message.getRepeatedField(msg, 1)) == null ? undefined : f,
    keywordsList: (f = jspb.Message.getRepeatedField(msg, 2)) == null ? undefined : f
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.DataAugmentation}
 */
proto.DataAugmentation.deserializeBinary = function(bytes) {
  var reader = new jspb.BinaryReader(bytes);
  var msg = new proto.DataAugmentation;
  return proto.DataAugmentation.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.DataAugmentation} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.DataAugmentation}
 */
proto.DataAugmentation.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = /** @type {string} */ (reader.readString());
      msg.addDomain(value);
      break;
    case 2:
      var value = /** @type {string} */ (reader.readString());
      msg.addKeywords(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.DataAugmentation.prototype.serializeBinary = function() {
  var writer = new jspb.BinaryWriter();
  proto.DataAugmentation.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.DataAugmentation} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.DataAugmentation.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getDomainList();
  if (f.length > 0) {
    writer.writeRepeatedString(
      1,
      f
    );
  }
  f = message.getKeywordsList();
  if (f.length > 0) {
    writer.writeRepeatedString(
      2,
      f
    );
  }
};


/**
 * repeated string domain = 1;
 * @return {!Array<string>}
 */
proto.DataAugmentation.prototype.getDomainList = function() {
  return /** @type {!Array<string>} */ (jspb.Message.getRepeatedField(this, 1));
};


/**
 * @param {!Array<string>} value
 * @return {!proto.DataAugmentation} returns this
 */
proto.DataAugmentation.prototype.setDomainList = function(value) {
  return jspb.Message.setField(this, 1, value || []);
};


/**
 * @param {string} value
 * @param {number=} opt_index
 * @return {!proto.DataAugmentation} returns this
 */
proto.DataAugmentation.prototype.addDomain = function(value, opt_index) {
  return jspb.Message.addToRepeatedField(this, 1, value, opt_index);
};


/**
 * Clears the list making it empty but non-null.
 * @return {!proto.DataAugmentation} returns this
 */
proto.DataAugmentation.prototype.clearDomainList = function() {
  return this.setDomainList([]);
};


/**
 * repeated string keywords = 2;
 * @return {!Array<string>}
 */
proto.DataAugmentation.prototype.getKeywordsList = function() {
  return /** @type {!Array<string>} */ (jspb.Message.getRepeatedField(this, 2));
};


/**
 * @param {!Array<string>} value
 * @return {!proto.DataAugmentation} returns this
 */
proto.DataAugmentation.prototype.setKeywordsList = function(value) {
  return jspb.Message.setField(this, 2, value || []);
};


/**
 * @param {string} value
 * @param {number=} opt_index
 * @return {!proto.DataAugmentation} returns this
 */
proto.DataAugmentation.prototype.addKeywords = function(value, opt_index) {
  return jspb.Message.addToRepeatedField(this, 2, value, opt_index);
};


/**
 * Clears the list making it empty but non-null.
 * @return {!proto.DataAugmentation} returns this
 */
proto.DataAugmentation.prototype.clearKeywordsList = function() {
  return this.setKeywordsList([]);
};



/**
 * List of repeated fields within this message type.
 * @private {!Array<number>}
 * @const
 */
proto.ProblemDescription.repeatedFields_ = [2,8,9];



if (jspb.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * Optional fields that are not set will be set to undefined.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     net/proto2/compiler/js/internal/generator.cc#kKeyword.
 * @param {boolean=} opt_includeInstance Deprecated. whether to include the
 *     JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @return {!Object}
 */
proto.ProblemDescription.prototype.toObject = function(opt_includeInstance) {
  return proto.ProblemDescription.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Deprecated. Whether to include
 *     the JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.ProblemDescription} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.ProblemDescription.toObject = function(includeInstance, msg) {
  var f, obj = {
    problem: (f = msg.getProblem()) && proto.Problem.toObject(includeInstance, f),
    inputsList: jspb.Message.toObjectList(msg.getInputsList(),
    proto.ProblemInput.toObject, includeInstance),
    id: jspb.Message.getFieldWithDefault(msg, 3, ""),
    version: jspb.Message.getFieldWithDefault(msg, 4, ""),
    name: jspb.Message.getFieldWithDefault(msg, 5, ""),
    description: jspb.Message.getFieldWithDefault(msg, 6, ""),
    digest: jspb.Message.getFieldWithDefault(msg, 7, ""),
    dataAugmentationList: jspb.Message.toObjectList(msg.getDataAugmentationList(),
    proto.DataAugmentation.toObject, includeInstance),
    otherNamesList: (f = jspb.Message.getRepeatedField(msg, 9)) == null ? undefined : f
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.ProblemDescription}
 */
proto.ProblemDescription.deserializeBinary = function(bytes) {
  var reader = new jspb.BinaryReader(bytes);
  var msg = new proto.ProblemDescription;
  return proto.ProblemDescription.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.ProblemDescription} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.ProblemDescription}
 */
proto.ProblemDescription.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = new proto.Problem;
      reader.readMessage(value,proto.Problem.deserializeBinaryFromReader);
      msg.setProblem(value);
      break;
    case 2:
      var value = new proto.ProblemInput;
      reader.readMessage(value,proto.ProblemInput.deserializeBinaryFromReader);
      msg.addInputs(value);
      break;
    case 3:
      var value = /** @type {string} */ (reader.readString());
      msg.setId(value);
      break;
    case 4:
      var value = /** @type {string} */ (reader.readString());
      msg.setVersion(value);
      break;
    case 5:
      var value = /** @type {string} */ (reader.readString());
      msg.setName(value);
      break;
    case 6:
      var value = /** @type {string} */ (reader.readString());
      msg.setDescription(value);
      break;
    case 7:
      var value = /** @type {string} */ (reader.readString());
      msg.setDigest(value);
      break;
    case 8:
      var value = new proto.DataAugmentation;
      reader.readMessage(value,proto.DataAugmentation.deserializeBinaryFromReader);
      msg.addDataAugmentation(value);
      break;
    case 9:
      var value = /** @type {string} */ (reader.readString());
      msg.addOtherNames(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.ProblemDescription.prototype.serializeBinary = function() {
  var writer = new jspb.BinaryWriter();
  proto.ProblemDescription.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.ProblemDescription} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.ProblemDescription.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getProblem();
  if (f != null) {
    writer.writeMessage(
      1,
      f,
      proto.Problem.serializeBinaryToWriter
    );
  }
  f = message.getInputsList();
  if (f.length > 0) {
    writer.writeRepeatedMessage(
      2,
      f,
      proto.ProblemInput.serializeBinaryToWriter
    );
  }
  f = message.getId();
  if (f.length > 0) {
    writer.writeString(
      3,
      f
    );
  }
  f = message.getVersion();
  if (f.length > 0) {
    writer.writeString(
      4,
      f
    );
  }
  f = message.getName();
  if (f.length > 0) {
    writer.writeString(
      5,
      f
    );
  }
  f = message.getDescription();
  if (f.length > 0) {
    writer.writeString(
      6,
      f
    );
  }
  f = message.getDigest();
  if (f.length > 0) {
    writer.writeString(
      7,
      f
    );
  }
  f = message.getDataAugmentationList();
  if (f.length > 0) {
    writer.writeRepeatedMessage(
      8,
      f,
      proto.DataAugmentation.serializeBinaryToWriter
    );
  }
  f = message.getOtherNamesList();
  if (f.length > 0) {
    writer.writeRepeatedString(
      9,
      f
    );
  }
};


/**
 * optional Problem problem = 1;
 * @return {?proto.Problem}
 */
proto.ProblemDescription.prototype.getProblem = function() {
  return /** @type{?proto.Problem} */ (
    jspb.Message.getWrapperField(this, proto.Problem, 1));
};


/**
 * @param {?proto.Problem|undefined} value
 * @return {!proto.ProblemDescription} returns this
*/
proto.ProblemDescription.prototype.setProblem = function(value) {
  return jspb.Message.setWrapperField(this, 1, value);
};


/**
 * Clears the message field making it undefined.
 * @return {!proto.ProblemDescription} returns this
 */
proto.ProblemDescription.prototype.clearProblem = function() {
  return this.setProblem(undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.ProblemDescription.prototype.hasProblem = function() {
  return jspb.Message.getField(this, 1) != null;
};


/**
 * repeated ProblemInput inputs = 2;
 * @return {!Array<!proto.ProblemInput>}
 */
proto.ProblemDescription.prototype.getInputsList = function() {
  return /** @type{!Array<!proto.ProblemInput>} */ (
    jspb.Message.getRepeatedWrapperField(this, proto.ProblemInput, 2));
};


/**
 * @param {!Array<!proto.ProblemInput>} value
 * @return {!proto.ProblemDescription} returns this
*/
proto.ProblemDescription.prototype.setInputsList = function(value) {
  return jspb.Message.setRepeatedWrapperField(this, 2, value);
};


/**
 * @param {!proto.ProblemInput=} opt_value
 * @param {number=} opt_index
 * @return {!proto.ProblemInput}
 */
proto.ProblemDescription.prototype.addInputs = function(opt_value, opt_index) {
  return jspb.Message.addToRepeatedWrapperField(this, 2, opt_value, proto.ProblemInput, opt_index);
};


/**
 * Clears the list making it empty but non-null.
 * @return {!proto.ProblemDescription} returns this
 */
proto.ProblemDescription.prototype.clearInputsList = function() {
  return this.setInputsList([]);
};


/**
 * optional string id = 3;
 * @return {string}
 */
proto.ProblemDescription.prototype.getId = function() {
  return /** @type {string} */ (jspb.Message.getFieldWithDefault(this, 3, ""));
};


/**
 * @param {string} value
 * @return {!proto.ProblemDescription} returns this
 */
proto.ProblemDescription.prototype.setId = function(value) {
  return jspb.Message.setProto3StringField(this, 3, value);
};


/**
 * optional string version = 4;
 * @return {string}
 */
proto.ProblemDescription.prototype.getVersion = function() {
  return /** @type {string} */ (jspb.Message.getFieldWithDefault(this, 4, ""));
};


/**
 * @param {string} value
 * @return {!proto.ProblemDescription} returns this
 */
proto.ProblemDescription.prototype.setVersion = function(value) {
  return jspb.Message.setProto3StringField(this, 4, value);
};


/**
 * optional string name = 5;
 * @return {string}
 */
proto.ProblemDescription.prototype.getName = function() {
  return /** @type {string} */ (jspb.Message.getFieldWithDefault(this, 5, ""));
};


/**
 * @param {string} value
 * @return {!proto.ProblemDescription} returns this
 */
proto.ProblemDescription.prototype.setName = function(value) {
  return jspb.Message.setProto3StringField(this, 5, value);
};


/**
 * optional string description = 6;
 * @return {string}
 */
proto.ProblemDescription.prototype.getDescription = function() {
  return /** @type {string} */ (jspb.Message.getFieldWithDefault(this, 6, ""));
};


/**
 * @param {string} value
 * @return {!proto.ProblemDescription} returns this
 */
proto.ProblemDescription.prototype.setDescription = function(value) {
  return jspb.Message.setProto3StringField(this, 6, value);
};


/**
 * optional string digest = 7;
 * @return {string}
 */
proto.ProblemDescription.prototype.getDigest = function() {
  return /** @type {string} */ (jspb.Message.getFieldWithDefault(this, 7, ""));
};


/**
 * @param {string} value
 * @return {!proto.ProblemDescription} returns this
 */
proto.ProblemDescription.prototype.setDigest = function(value) {
  return jspb.Message.setProto3StringField(this, 7, value);
};


/**
 * repeated DataAugmentation data_augmentation = 8;
 * @return {!Array<!proto.DataAugmentation>}
 */
proto.ProblemDescription.prototype.getDataAugmentationList = function() {
  return /** @type{!Array<!proto.DataAugmentation>} */ (
    jspb.Message.getRepeatedWrapperField(this, proto.DataAugmentation, 8));
};


/**
 * @param {!Array<!proto.DataAugmentation>} value
 * @return {!proto.ProblemDescription} returns this
*/
proto.ProblemDescription.prototype.setDataAugmentationList = function(value) {
  return jspb.Message.setRepeatedWrapperField(this, 8, value);
};


/**
 * @param {!proto.DataAugmentation=} opt_value
 * @param {number=} opt_index
 * @return {!proto.DataAugmentation}
 */
proto.ProblemDescription.prototype.addDataAugmentation = function(opt_value, opt_index) {
  return jspb.Message.addToRepeatedWrapperField(this, 8, opt_value, proto.DataAugmentation, opt_index);
};


/**
 * Clears the list making it empty but non-null.
 * @return {!proto.ProblemDescription} returns this
 */
proto.ProblemDescription.prototype.clearDataAugmentationList = function() {
  return this.setDataAugmentationList([]);
};


/**
 * repeated string other_names = 9;
 * @return {!Array<string>}
 */
proto.ProblemDescription.prototype.getOtherNamesList = function() {
  return /** @type {!Array<string>} */ (jspb.Message.getRepeatedField(this, 9));
};


/**
 * @param {!Array<string>} value
 * @return {!proto.ProblemDescription} returns this
 */
proto.ProblemDescription.prototype.setOtherNamesList = function(value) {
  return jspb.Message.setField(this, 9, value || []);
};


/**
 * @param {string} value
 * @param {number=} opt_index
 * @return {!proto.ProblemDescription} returns this
 */
proto.ProblemDescription.prototype.addOtherNames = function(value, opt_index) {
  return jspb.Message.addToRepeatedField(this, 9, value, opt_index);
};


/**
 * Clears the list making it empty but non-null.
 * @return {!proto.ProblemDescription} returns this
 */
proto.ProblemDescription.prototype.clearOtherNamesList = function() {
  return this.setOtherNamesList([]);
};


/**
 * @enum {number}
 */
proto.TaskKeyword = {
  TASK_KEYWORD_UNDEFINED: 0,
  CLASSIFICATION: 1,
  REGRESSION: 2,
  CLUSTERING: 3,
  LINK_PREDICTION: 4,
  VERTEX_NOMINATION: 5,
  VERTEX_CLASSIFICATION: 6,
  COMMUNITY_DETECTION: 7,
  GRAPH_MATCHING: 8,
  FORECASTING: 9,
  COLLABORATIVE_FILTERING: 10,
  OBJECT_DETECTION: 11,
  SEMISUPERVISED: 12,
  BINARY: 13,
  MULTICLASS: 14,
  MULTILABEL: 15,
  UNIVARIATE: 16,
  MULTIVARIATE: 17,
  OVERLAPPING: 18,
  NONOVERLAPPING: 19,
  TABULAR: 20,
  RELATIONAL: 21,
  IMAGE: 22,
  AUDIO: 23,
  VIDEO: 24,
  SPEECH: 25,
  TEXT: 26,
  GRAPH: 27,
  MULTIGRAPH: 28,
  TIME_SERIES: 29,
  GROUPED: 30,
  GEOSPATIAL: 31,
  REMOTE_SENSING: 32,
  LUPI: 33,
  MISSING_METADATA: 34
};

/**
 * @enum {number}
 */
proto.PerformanceMetric = {
  METRIC_UNDEFINED: 0,
  ACCURACY: 1,
  PRECISION: 2,
  RECALL: 3,
  F1: 4,
  F1_MICRO: 5,
  F1_MACRO: 6,
  ROC_AUC: 7,
  ROC_AUC_MICRO: 8,
  ROC_AUC_MACRO: 9,
  MEAN_SQUARED_ERROR: 10,
  ROOT_MEAN_SQUARED_ERROR: 11,
  MEAN_ABSOLUTE_ERROR: 12,
  R_SQUARED: 13,
  NORMALIZED_MUTUAL_INFORMATION: 14,
  JACCARD_SIMILARITY_SCORE: 15,
  PRECISION_AT_TOP_K: 16,
  OBJECT_DETECTION_AVERAGE_PRECISION: 17,
  HAMMING_LOSS: 18,
  RANK: 99,
  LOSS: 100
};

goog.object.extend(exports, proto);
